"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.verifyPaymentChannelClaim = exports.signPaymentChannelClaim = exports.deriveXAddress = exports.deriveAddress = exports.deriveKeypair = exports.generateXAddress = exports.generateAddress = exports.computePaymentChannelHash = exports.computeEscrowHash = exports.computeLedgerHash = exports.computeStateTreeHash = exports.computeTransactionTreeHash = exports.computeTrustlineHash = exports.computeOrderID = exports.computeSignerListLedgerObjectID = exports.computeAccountLedgerObjectID = exports.computeBinaryTransactionSigningHash = exports.computeTransactionHash = exports.computeBinaryTransactionHash = exports.isValidSecret = exports.iso8601ToRippleTime = exports.rippleTimeToISO8601 = exports.removeUndefined = exports.convertKeysFromSnakeCaseToCamelCase = exports.toRippledAmount = exports.xrpToDrops = exports.dropsToXrp = exports.computeLedgerHeaderHash = void 0;
const derive_1 = require("./derive");
Object.defineProperty(exports, "deriveKeypair", { enumerable: true, get: function () { return derive_1.deriveKeypair; } });
Object.defineProperty(exports, "deriveAddress", { enumerable: true, get: function () { return derive_1.deriveAddress; } });
Object.defineProperty(exports, "deriveXAddress", { enumerable: true, get: function () { return derive_1.deriveXAddress; } });
const ledgerhash_1 = __importDefault(require("./ledgerhash"));
exports.computeLedgerHeaderHash = ledgerhash_1.default;
const sign_payment_channel_claim_1 = __importDefault(require("./sign-payment-channel-claim"));
exports.signPaymentChannelClaim = sign_payment_channel_claim_1.default;
const verify_payment_channel_claim_1 = __importDefault(require("./verify-payment-channel-claim"));
exports.verifyPaymentChannelClaim = verify_payment_channel_claim_1.default;
const utils_1 = require("../common/utils");
Object.defineProperty(exports, "dropsToXrp", { enumerable: true, get: function () { return utils_1.dropsToXrp; } });
Object.defineProperty(exports, "xrpToDrops", { enumerable: true, get: function () { return utils_1.xrpToDrops; } });
Object.defineProperty(exports, "toRippledAmount", { enumerable: true, get: function () { return utils_1.toRippledAmount; } });
Object.defineProperty(exports, "convertKeysFromSnakeCaseToCamelCase", { enumerable: true, get: function () { return utils_1.convertKeysFromSnakeCaseToCamelCase; } });
Object.defineProperty(exports, "removeUndefined", { enumerable: true, get: function () { return utils_1.removeUndefined; } });
Object.defineProperty(exports, "rippleTimeToISO8601", { enumerable: true, get: function () { return utils_1.rippleTimeToISO8601; } });
Object.defineProperty(exports, "iso8601ToRippleTime", { enumerable: true, get: function () { return utils_1.iso8601ToRippleTime; } });
Object.defineProperty(exports, "isValidSecret", { enumerable: true, get: function () { return utils_1.isValidSecret; } });
const hashes_1 = require("../common/hashes");
Object.defineProperty(exports, "computeBinaryTransactionHash", { enumerable: true, get: function () { return hashes_1.computeBinaryTransactionHash; } });
Object.defineProperty(exports, "computeTransactionHash", { enumerable: true, get: function () { return hashes_1.computeTransactionHash; } });
Object.defineProperty(exports, "computeBinaryTransactionSigningHash", { enumerable: true, get: function () { return hashes_1.computeBinaryTransactionSigningHash; } });
Object.defineProperty(exports, "computeAccountLedgerObjectID", { enumerable: true, get: function () { return hashes_1.computeAccountLedgerObjectID; } });
Object.defineProperty(exports, "computeSignerListLedgerObjectID", { enumerable: true, get: function () { return hashes_1.computeSignerListLedgerObjectID; } });
Object.defineProperty(exports, "computeOrderID", { enumerable: true, get: function () { return hashes_1.computeOrderID; } });
Object.defineProperty(exports, "computeTrustlineHash", { enumerable: true, get: function () { return hashes_1.computeTrustlineHash; } });
Object.defineProperty(exports, "computeTransactionTreeHash", { enumerable: true, get: function () { return hashes_1.computeTransactionTreeHash; } });
Object.defineProperty(exports, "computeStateTreeHash", { enumerable: true, get: function () { return hashes_1.computeStateTreeHash; } });
Object.defineProperty(exports, "computeLedgerHash", { enumerable: true, get: function () { return hashes_1.computeLedgerHash; } });
Object.defineProperty(exports, "computeEscrowHash", { enumerable: true, get: function () { return hashes_1.computeEscrowHash; } });
Object.defineProperty(exports, "computePaymentChannelHash", { enumerable: true, get: function () { return hashes_1.computePaymentChannelHash; } });
const generate_address_1 = require("../offline/generate-address");
Object.defineProperty(exports, "generateXAddress", { enumerable: true, get: function () { return generate_address_1.generateAddressAPI; } });
const generateAddress = (options = {}) => (generate_address_1.generateAddressAPI(Object.assign(Object.assign({}, options), { includeClassicAddress: true })));
exports.generateAddress = generateAddress;
//# sourceMappingURL=utils.js.map